﻿using System;
using System.ComponentModel;
using System.Windows.Media.Imaging;
using System.IO;

namespace SilvelightViewModelOpenFileDialog
{
    public class MainPageModel : INotifyPropertyChanged
    {
        public MainPageModel()
        {

        }

        // Operations
        private void SetImage()
        {
            using (Stream stream = SelectedFileProperty.OpenRead())
            {
                BitmapImage image = new BitmapImage();
                image.SetSource(stream);
                SelectedImageProperty = image;
            }
        }

        #region SelectedFileProperty
        private FileInfo _SelectedFileProperty;
        public FileInfo SelectedFileProperty
        {
            get
            {
                return this._SelectedFileProperty;
            }
            set
            {
                if (SelectedFileProperty == value)
                {
                    return;
                }
                _SelectedFileProperty = value;
                this.NotifyPropertyChanged("SelectedFileProperty");
                SetImage();
            }
        }
        #endregion

        #region SelectedImageProperty
        private BitmapSource _SelectedImageProperty;
        public BitmapSource SelectedImageProperty
        {
            get
            {
                return this._SelectedImageProperty;
            }
            set
            {
                if (SelectedImageProperty == value)
                {
                    return;
                }

                _SelectedImageProperty = value;
                this.NotifyPropertyChanged("SelectedImageProperty");
            }
        }
        #endregion

        #region INotifyPropertyChanged
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
        #endregion
    }
}